"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ChartProvider = exports.ChartContext = void 0;

var _react = _interopRequireDefault(require("react"));

var _misc = require("./misc");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var ChartContext = /*#__PURE__*/_react["default"].createContext({});

exports.ChartContext = ChartContext;
var Provider = ChartContext.Provider;

var ChartProvider = function ChartProvider(props) {
  var data = props.data,
      echartsOptions = props.echartsOptions;

  var _ref = echartsOptions || {},
      userOptions = _ref.option;

  return /*#__PURE__*/_react["default"].createElement(Provider, {
    value: {
      data: data,
      echartsOptions: echartsOptions,
      echartsOptionsBase: _misc.echartsOptionsBase,
      userOptions: userOptions
    }
  }, props.children);
};

exports.ChartProvider = ChartProvider;